//+------------------------------------------------------------------+
//|                                          market order ecnv12.mq4 |
//|                                                                  |
//|                                                  http://www..com |
//+------------------------------------------------------------------+


#property copyright ""
//-----------------------------------------------------------------------------+
// External Variables
extern bool   DynamicLotSize = false;
extern double EquityPercent  =   1;
extern double FixedLotSize   = 0.01;
extern double Multiplier     =   2;
extern double LotDigits      =   2;
extern double StopLoss       =  50;
extern double TakeProfit     =  20;
extern double TrailingStop   =   2;
extern int    MinimumProfit  =   3;
extern int    Slippage       =   3;
extern double OpenDistance   =   2;
extern double ReturnDist     =   1;
extern double MinStop        =   1;
extern int    MagicNumber    = 08012013;
extern int    MaxOrders      =   7;     //Phil: MaxOrders
//-----------------------------------------------------------------------------+
// Global Variables
int BuyTicket,SellTicket, RealSlippage,total;
double pt;
double volume_previous = 0;

// Phil: use bool variables for 'ping pong'
bool BuyAllowed=true,SellAllowed=true;
// Phil: HelperVars for odercount
int OTCurrentTick, OTLastTick;
//-----------------------------------------------------------------------------+
int init ()// Adjust for 4 or 5 digits.
   {
   if (Digits == 2 || Digits == 4) 
      {
      pt = Point;
      RealSlippage = Slippage;
      }    
   if (Digits == 3 || Digits == 5) 
      {
      pt = Point * 10;
      RealSlippage = Slippage * 10;
      }
      
// Phil: get current status of the EA
   int LastClosedTicket=GetTicketFromHistory(Symbol(),MagicNumber);  //get last ticket
   if(LastClosedTicket>0){                                           //if there is any
      Print("LastClosedTicket=",LastClosedTicket);                   //print it
      if(OrderSelect(LastClosedTicket,SELECT_BY_TICKET)){            //select it
         if(OrderType()==OP_BUY){BuyAllowed=false;SellAllowed=true;} //initalize 'ping pong'
         else                   {BuyAllowed=true;SellAllowed=false;} 
      }   
   }     
         
  return(0);   
 }
 
//+---------------------------------------------------------------------------+
int start()// A line is used to get orders opening above or under this line more or minus OpenDistance. The reason of the line is that don't know how to use datetime to get it.
 {//0 
   
 //************************************************************************************************************
 //Phil: Add this block into a function and call it if needed. I doubt calc the lotsize is necessary on every tick
  
  //+---------------------------------------------------------------------------+	         		
  // Lot size calculation
  // Here I put limits to lot size in terms if wich equity I want to negociate(%). 
  //Also The lot size is dependant of the StopLoss.

   if(DynamicLotSize == true)
      {//1
      double RiskAmount = AccountEquity() * (EquityPercent / 100);
      double TickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
           
      if(Point == 0.001 || Point == 0.00001) TickValue *= 10;
      double LotSize = (RiskAmount / StopLoss) / TickValue;
      }//1
   else LotSize = FixedLotSize;
          
  //+---------------------------------------------------------------------------+     
  // Lot size verification. Here the minimum and max lot size is verified and LotStep.

  if(LotSize < MarketInfo(Symbol(),MODE_MINLOT))
     {//2
     LotSize = MarketInfo(Symbol(),MODE_MINLOT);
     }//2
  else if(LotSize > MarketInfo(Symbol(),MODE_MAXLOT))
     {//3
     LotSize = MarketInfo(Symbol(),MODE_MAXLOT);
     }//3
     	
  if(MarketInfo(Symbol(),MODE_LOTSTEP) == 0.1)
     {//4
     LotSize = NormalizeDouble(LotSize,1);
     }//4
  else LotSize = LotSize;	
   	
 //+----------------------------------------------------------------------------+		
 //************************************************************************************************************

 
  //Phil: 
  //Check the total amount of  orders. I would add a filter for market, magic and symbol...
  //.... but i am lazy now.....it is something for you to do.
  OTLastTick=OTCurrentTick;                      //shift OrderTotal
  OTCurrentTick=OrdersTotal();                   //reinit OrderTotal
  if(OTCurrentTick>0)Trail();                    //Trail
  if(OTLastTick>=2                               //if OrderTotal has changed
     &&OTCurrentTick<OTLastTick
     &&OTCurrentTick>0)CloseAllOnTP();           //Check order closed on TP level
  if(OTCurrentTick>=MaxOrders)return;            //Dont open more orders. Trail and return.
                                                 //Actually we have nothing more to do.

  
  if(OTCurrentTick==0){//init serie
     BuyAllowed=true;
     SellAllowed=true; 

  //Only use that part of the code for the very first order of a serie
 
  // Buy Order Condition to Open
  //if(OpenDistance*pt && BuyTicket==0)    <-- Luis
    if(OpenDistance*pt && BuyAllowed)    //<-- Phil
	  {//5	
	  while(IsTradeContextBusy()) Sleep(10);
	  RefreshRates();	
		       
     BuyTicket=OrderSend(Symbol(),OP_BUY,LotSize,Ask,RealSlippage,0,0,"Buy Order",MagicNumber,0,Green);
     if(BuyTicket > -1)
        {//6
         BuyAllowed=false;SellAllowed=true;                                          // <-- ping pong        
         Print("Opposite Buy order placed # ",BuyTicket);
         AddLimitsBuy();        
         }//6
      else
         {//7 
         Print("Order Send failed, error # ", GetLastError());
         }//7 
         
      return(0);
      }//5
  //-----------------------------------------------------------------------------+	
  
  // Sell Order Condition to Open

  //if(OpenDistance*pt && SellTicket == 0)    <-- Luis
    if(OpenDistance*pt && SellAllowed)      //<-- Phil                   
     {//8                                 
	  while(IsTradeContextBusy()) Sleep(10);
	  RefreshRates();	
				 		
	  SellTicket=OrderSend(Symbol(),OP_SELL,LotSize,Bid,RealSlippage,0,0,"Sell Order",MagicNumber,0,Red);
	  if(SellTicket > -1)
 		  {//9
 		  BuyAllowed=true;SellAllowed=false;                                          // <-- ping pong        
        Print("Opposite Sell order placed # ", SellTicket);
        AddLimitsSell();       
        }//9
     else
        {//10
        Print("Order Send failed, error # ", GetLastError());
        }//10      
     return(0);
     }//8
     
  }//Phil: end init serie				 				
   //+---------------------------------------------------------------------------+  
   //Last Order Loss Compensation (increase size of last lot if not in profit)

/* Phil: Martingale attempt removed. Bear in mind, martingale isn't a reliable strategy.
         if you really want running code, look here: http://forum.mql4.com/53241#739269

   double LastProfit,LastLot,MLots;
    
   for(int i = 0; i < OrdersTotal(); i++)
       {//11
       if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
          {//12
          if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)
             {//13
              LastProfit = OrderProfit();
              LastLot = OrderLots();
             }//13 
             
          MLots = 0;              
          if (LastProfit < 0) MLots = LastLot * Multiplier;
          }//12
       else MLots = LotSize;
       }//11 
 */            
//+------------------------------------------------------------------+ 
//Open Opposite Order (open opposite order if last order not reach TakeProfit)
//Here extra code was introduced to limit multiple orders. Ticket--> BuyTicket and SellTicket

//Phil: I would move that block to a function, but i am lazy now.....it is something for you to do.
 
   int Op;  
   
   for(int Counter = OrdersTotal()-1; Counter >= 0; Counter--)
      {//14
      if(OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES))  
         {//15
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)
            {//16
            Op = OrderType();

            //if(Op == OP_BUY && Bid < OrderOpenPrice() - (ReturnDist*pt) && SellTicket == 0) // <-- Luis
            if(Op == OP_BUY && Bid < OrderOpenPrice() - (ReturnDist*pt) && SellAllowed)       // <-- Phil
               {//17               
               SellTicket = OrderSend(Symbol(), OP_SELL, LotSize, Bid, RealSlippage, 0, 0, "Sell Order", MagicNumber, 0, Red); //Phil: Martingale MLots removed
               if(SellTicket > -1) 
                  {//18
                  BuyAllowed=true;SellAllowed=false;                                          // <-- ping pong
                  Print("Opposite Sell order placed # ", SellTicket);
                  AddLimitsSell();
                  }//18
               else
                  {//19
                  Print("Order Send failed, error # ", GetLastError() );
                  }//19
                }//17
                           
            //if(Op == OP_SELL && Ask > OrderOpenPrice() + (ReturnDist*pt)&& BuyTicket == 0)  // <-- Luis
            if(Op == OP_SELL && Ask > OrderOpenPrice() + (ReturnDist*pt)&& BuyAllowed)        // <-- Phil
               {//20             
               BuyTicket = OrderSend(Symbol(), OP_BUY, LotSize, Ask, RealSlippage, 0, 0, "Buy Order", MagicNumber, 0, Green); //Phil: Martingale MLots removed
               if(BuyTicket > -1)
                  {//21
                  BuyAllowed=false;SellAllowed=true;                                          // <-- ping pong                  
                  Print("Opposite Buy order placed # ", BuyTicket);
                  AddLimitsBuy();
                  }//21
               else
                  {//22  
                  Print("Order Send failed, error # ", GetLastError());
                  }//22   
               }//20
            }//16
         }//15    
      }//14
           
   //+------------------------------------------------------------------+  
   //Trailing Stop. Here the Minimum Profit TrailingStop will start when order profit reach a minimum profit
   // above or under the orderOpenPrice.In this case when MinimumProfit is 5 pips TrailingStop goes to 3 pips after the OrderOpenPrice.

   //Phil: block moved to Trail();
   //      Trail() is called at the beginning of start, you'll find out why

    
   //+------------------------------------------------------------------+  

   // Close All(close all open positions if last one reach TakeProfit) 
   //Here I don't know how to close all opened orders when TrailingStop closes the order. Think that orderProfit() > 0 is not the righ way...

   //Phil: block moved to CloseAllOnTP();
   //      
   //+------------------------------------------------------------------+  
   
  return(0);
  }//0 
                       
  //+------------------------------------------------------------------+
  //Add limits after sent order for ECN Brokers)    This block besides to add the order limits it wil look to put the limits outside the Freeze zone

   void  AddLimitsBuy()
      {
      OrderSelect(BuyTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice();

      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
      RefreshRates();	
      double UpperStopLevel = Ask + StopLevel;
      double LowerStopLevel = Bid - StopLevel;
				       				      
      if(StopLoss > 0) 
        double BuyStopLoss  = OpenPrice - (StopLoss * pt);
      
      if(TakeProfit > 0) 
        double BuyTakeProfit = OpenPrice + (TakeProfit * pt);
				      
      if(BuyStopLoss > 0 && BuyStopLoss > LowerStopLevel) 
	     {					
	  	  BuyStopLoss = LowerStopLevel - (MinStop*pt);
		  }
				      
	   if(BuyTakeProfit > 0 && BuyTakeProfit < UpperStopLevel) 
	     {
	     BuyTakeProfit = UpperStopLevel + (MinStop*pt);
	     }

	   if(IsTradeContextBusy())
	      Sleep(10);	

     if(BuyStopLoss > 0 || BuyTakeProfit > 0) 
        {		
        OrderModify(BuyTicket,OpenPrice,BuyStopLoss,BuyTakeProfit,0);                            
        }
     } 
   //+------------------------------------------------------------------+
   //Add limits after sent order (ECN Brokers)     This block besides to add the order limits it wil look to put the limits outside the Freeze zone

   void   AddLimitsSell()
      {
      OrderSelect(SellTicket,SELECT_BY_TICKET);
      double OpenPrice = OrderOpenPrice(); 
                 
      double StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
	   RefreshRates();	
	   double UpperStopLevel = Ask + StopLevel;
	   double LowerStopLevel = Bid - StopLevel;
				      				      
	   if(StopLoss > 0) 
	     double SellStopLoss = OpenPrice + (StopLoss * pt);
	   
      if(TakeProfit > 0) 
        double SellTakeProfit = OpenPrice - (TakeProfit * pt);
				      
	   if(SellStopLoss > 0 && SellStopLoss < UpperStopLevel) 
	     {					
		  SellStopLoss = UpperStopLevel + (MinStop*pt);
		  }
		
	   if(SellTakeProfit > 0 && SellTakeProfit > LowerStopLevel) 
		  {
	     SellTakeProfit = LowerStopLevel - (MinStop*pt);
		  }
					      
	   if(IsTradeContextBusy()) 
	     Sleep(10);	

      if(SellStopLoss > 0 || SellTakeProfit > 0) 
         {		
         OrderModify(SellTicket,OpenPrice,SellStopLoss,SellTakeProfit,0);
         }                    
     }
//+------------------------------------------------------------------+     
   //+------------------------------------------------------------------+  
   //Trailing Stop. Here the Minimum Profit TrailingStop will start when order profit reach a minimum profit
   // above or under the orderOpenPrice.In this case when MinimumProfit is 5 pips TrailingStop goes to 3 pips after the OrderOpenPrice.


void Trail(){
   if(TrailingStop > 0)         
      for(int OrderCounter = 0; OrderCounter < OrdersTotal(); OrderCounter++)
         {//23
         OrderSelect(OrderCounter,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_BUY && OrderSymbol()== Symbol() 
            && OrderMagicNumber()== MagicNumber)
            {//24
            if(OrderStopLoss() < MarketInfo(Symbol(),MODE_BID) - TrailingStop*pt && MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice() >= MinimumProfit*pt)
               {//25
               OrderModify(OrderTicket(),OrderOpenPrice(),MarketInfo(Symbol(),MODE_BID) - TrailingStop*pt,OrderTakeProfit(),0,Yellow);  
               }//25
             }//24
           }//23          
           if(OrderType()==OP_SELL && OrderSymbol()== Symbol() 
              && OrderMagicNumber()== MagicNumber)
              {//26
              if(OrderStopLoss() > MarketInfo(Symbol(),MODE_ASK) + TrailingStop*pt && OrderOpenPrice() - MarketInfo(Symbol(),MODE_ASK) >= MinimumProfit*pt)
                 {//27
                  OrderModify(OrderTicket(),OrderOpenPrice(),MarketInfo(Symbol(),MODE_ASK) + TrailingStop*pt,OrderTakeProfit(),0,Yellow);
                 }//27
              return(0);     
              }//26   
}
//+------------------------------------------------------------------+  
   // Close All(close all open positions if last one reach TakeProfit) 
   //Here I don't know how to close all opened orders when TrailingStop closes the order. Think that orderProfit() > 0 is not the righ way...

   //Phil: Not sure what you mean? You mention OrderProfit, but you dont use it?
   //      Find out wheter an order is closed, closed by TP or closed by SL is actually tricky!
   //      On several posts in the formum is stated, OrderComment is not reliable, so you cannot check for [sl],[tp] or no suffix
   //      The below has the limitation, it does only decide between tp and sl, but has no clue if the EA has closed the order 
   //      Let me know if you have a better idea :-) Cheers

void CloseAllOnTP(){
   int OrdType, GLError;
   double OrderClosed;
   RefreshRates();

//Phil
   int LastClosedTicket=GetTicketFromHistory(Symbol(),MagicNumber);  //get last ticket
   if(LastClosedTicket>0){//28                                       //if there is any
      Print("LastClosedTicket=",LastClosedTicket);                   //print it
      if(OrderSelect(LastClosedTicket,SELECT_BY_TICKET)){//29        //select it
         if(MathAbs(OrderTakeProfit()-OrderClosePrice())<            //calc abs distance between tp and cp
            MathAbs(OrderStopLoss()-OrderClosePrice())){//30         //calc abs distance between sl and cp
            Print("Order with ticketnr: ", LastClosedTicket,
                  " hit TP! Close all open orders");
//Luis
      for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)       
         if(OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
            && OrderMagicNumber()== MagicNumber 
            && OrderSymbol()== Symbol())                                       
            {//31
            OrdType = OrderType();
            if(OrdType == OP_BUY || OrdType==OP_SELL)
              {//32
              if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),RealSlippage, Yellow))
                  GLError = GetLastError();
              }//32
                      
             if(!ObjectsDeleteAll())
                 GLError = GetLastError();
             }//31      
         }//28 End Phil
      }//29 End Phil     
   }//30 End Phil
 /* Luis  
    for(int Closed = OrdersTotal()-1;Closed >= 0; Closed--) 
      if(OrderSelect(Closed,SELECT_BY_POS,MODE_HISTORY)==true
        && OrderMagicNumber()== MagicNumber
        && OrderSymbol()== Symbol())
        {//29
        OrderClosed = OrderCloseTime();
        if(OrderClosed!=0)
           {//30 
                                            
   for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)       
      if(OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
         && OrderMagicNumber()== MagicNumber 
         && OrderSymbol()== Symbol())                                       
         {//31
         OrdType = OrderType();
         if(OrdType == OP_BUY || OrdType==OP_SELL)
           {//32
           if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),RealSlippage, Yellow))
               GLError = GetLastError();
           }//32
                      
          if(!ObjectsDeleteAll())
              GLError = GetLastError();
          }//31
       }//30
     }//29 
*/  
  if(GLError > 0) Print("Error Closing/Deleting Order, error # ", GLError, " for ticket: ", OrderTicket());           
}

//+------------------------------------------------------------------+
//| Name    :GetTicketFromHistory
//| Input   :Symbol
//|         :MagicNumber
//|         :orderposinhistory
//| Return  :ticketnr
//| Comment :http://forum.mql4.com/46182 states that the order in the 
//|          in the history pool is not reliable. Therefore create 
//|          a sorted list and search for the matching OrderCloseTime.
//+------------------------------------------------------------------+
int GetTicketFromHistory(string sym,int mn,int orderposinhistory=0){
   bool debug=false;
   if(debug)Print("Orders in history: ", OrdersHistoryTotal());
   int ticket,count=1,i;
   datetime orderclosedates[];
   for(i=OrdersHistoryTotal()-1;i>=0;i--){
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
      if(debug)Print("OrderSymbol: ",OrderSymbol(),"; OrderMagicNumber: ",OrderMagicNumber(),
                     " ;OrderType: ",OrderType(),"; OrderTicket: ",OrderTicket(),
                     "; OrderCloseTime: ",TimeToStr(OrderCloseTime()),";"); 
      if((OrderMagicNumber()  ==mn)
         &&(OrderSymbol()     ==sym)
         &&(OrderType()==OP_BUY||OrderType()==OP_SELL)){                       
         ArrayResize(orderclosedates,count);
         orderclosedates[count-1]=OrderCloseTime();
         count++;
      }
   }
   if(ArraySize(orderclosedates)>0){
      if(debug)Print("ArraySize (Orders found): ",ArraySize(orderclosedates));
      if(ArraySize(orderclosedates)>orderposinhistory){                         
         ArraySort(orderclosedates,WHOLE_ARRAY,0,MODE_DESCEND);
         for(i=OrdersHistoryTotal()-1;i>=0;i--){
            if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
            if(OrderCloseTime()==orderclosedates[orderposinhistory]){
               ticket=OrderTicket();
               if(debug)Print("Orderticket for order ",orderposinhistory," in history: ",ticket);
               break;      
            }
         }    
      }else{
         if(debug)Print("Not enough matching orders in history!");
      }
   }   
   return(ticket);   
}

         
       


